Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/ListItemValueField.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/ListItemValueField.java	(revision 0)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/ListItemValueField.java	(revision 168)
@@ -0,0 +1,107 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+*
+* Copyright (C) 2007-2008 Infrastructures and Transports Department
+* of the Valencian Government (CIT)
+* 
+* This program is free software; you can redistribute it and/or
+* modify it under the terms of the GNU General Public License
+* as published by the Free Software Foundation; either version 2
+* of the License, or (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
+* MA  02110-1301, USA.
+* 
+*/
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 Institute of New Imaging Technologies (INIT): 
+ *   http://www.init.uji.es
+ * Geographic Information research group: 
+ *   http://www.geoinfo.uji.es
+ * Universitat Jaume I, Spain
+ */
+
+/**
+ * 
+ */
+package org.gvsig.tools.swing.impl.dynobject;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.gvsig.tools.dynobject.DynField;
+import org.gvsig.tools.dynobject.DynObject;
+import org.gvsig.tools.swing.api.dynobject.dynfield.ValueField;
+
+/**
+ * @author <a href="mailto:reinhold@uji.es">cmartin</a>
+ *
+ */
+public class ListItemValueField  implements ValueField {
+
+    private List<Object> items;
+    private Object defaultValue;
+
+    /**
+     * @param dynObject
+     * @param fieldName
+     */
+    public ListItemValueField(DynObject dynObject,String fieldName, int index) {
+	
+	Object value = dynObject.getDynValue(fieldName);
+
+	this.items = new ArrayList<Object>();
+	if (value!=null){
+	    this.setValue(value);
+	    return;
+	}
+	   
+	DynField fieldType = dynObject.getDynClass().getDynField(fieldName);
+	this.defaultValue = fieldType.getDefaultValue();
+	if (defaultValue!=null)
+	    this.setValue(defaultValue);
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.ValueField#getDefaultValue()
+     */
+    public Object getDefaultValue() {
+	return this.defaultValue;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.ValueField#getValue()
+     */
+    public Object getValue() {
+	return this.items;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.ValueField#getValue()
+     */
+    public Object getValueItem(int index) {
+	return this.items.get(index);
+    }
+    
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.ValueField#setValue(java.lang.Object)
+     */
+    public void setValue(Object value) {
+	this.items = (List<Object>) value;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.ValueField#setValue(java.lang.Object)
+     */
+    public void setValueItem(Object item, int index) {
+	this.items.set(index, item);
+    }
+}
Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JComboBoxDynFieldComponent.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JComboBoxDynFieldComponent.java	(revision 0)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JComboBoxDynFieldComponent.java	(revision 168)
@@ -0,0 +1,196 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+*
+* Copyright (C) 2007-2008 Infrastructures and Transports Department
+* of the Valencian Government (CIT)
+* 
+* This program is free software; you can redistribute it and/or
+* modify it under the terms of the GNU General Public License
+* as published by the Free Software Foundation; either version 2
+* of the License, or (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
+* MA  02110-1301, USA.
+* 
+*/
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 Institute of New Imaging Technologies (INIT): 
+ *   http://www.init.uji.es
+ * Geographic Information research group: 
+ *   http://www.geoinfo.uji.es
+ * Universitat Jaume I, Spain
+ */
+
+/**
+ * 
+ */
+package org.gvsig.tools.swing.impl.dynobject.dynfield;
+
+import java.awt.event.ItemEvent;
+import java.awt.event.ItemListener;
+
+import javax.swing.JComboBox;
+
+import org.gvsig.tools.dynobject.DynField;
+import org.gvsig.tools.dynobject.DynObjectValueItem;
+import org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent;
+import org.gvsig.tools.swing.spi.DelegatedJFieldComponent;
+
+/**
+ * @author <a href="mailto:reinhold@uji.es">cmartin</a>
+ *
+ */
+public class JComboBoxDynFieldComponent extends DelegatedJFieldComponent implements JDynFieldComponent, ItemListener{
+
+    private JComboBox combo;
+    private DynObjectValueItem[] items;
+
+    /**
+     * @param component
+     */
+    public JComboBoxDynFieldComponent(JDynFieldComponent component, DynField dynField) {
+	super(component, dynField);
+    }
+
+    /**
+     * 
+     */
+    protected void afterUI() {
+	Object value = this.getFieldValue();
+	Object item;
+	if (value!=null)
+	   for (int i=0;i<this.items.length;i++){
+	       item = items[i].getValue();
+	       if (item==null) continue;
+	       if (item.equals(value)){
+		   this.combo.setSelectedIndex(i+1);
+		   break;
+	       }
+	   }
+    }
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.JComponent#getComponent()
+     */
+    public Object getComponent() {
+	return this.combo;
+    }
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#getValue()
+     */
+    @Override
+    public Object getValue() {
+	int index = this.combo.getSelectedIndex();
+	if ((isMandatory())&&(index<1))
+	    return null;
+	else
+	    //null is at combo position 0, so the index is one unit ahead as of the items index
+	    return this.items[index-1].getValue();
+    }
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.AbstractJDynField#initData()
+     */
+    @Override
+    protected void initData() {
+	
+    }
+
+    /**
+     * 
+     */
+    protected void initUI() {
+	items = getDynField().getAvailableValues();
+	this.combo = new JComboBox();
+	this.combo.addItem(null);
+	for (DynObjectValueItem item : items){
+	    this.combo.addItem(item.getLabel());
+	}
+	this.combo.setSelectedIndex(0);
+	this.combo.addItemListener(this);
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#isValid()
+     */
+    public boolean isValid() {
+	return this.combo.getSelectedIndex()>0;
+    }
+
+    /* (non-Javadoc)
+     * @see java.awt.event.ItemListener#itemStateChanged(java.awt.event.ItemEvent)
+     */
+    public void itemStateChanged(ItemEvent evt) {
+        this.fireValueChangedEvent();
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#requestFocus()
+     */
+    public void requestFocus() {
+	this.combo.requestFocus();
+    }
+
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#saveStatus()
+     */
+    public void saveStatus() {
+	this.setFieldValue(this.getValue());
+    }
+
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#setEnabled(boolean)
+     */
+    public void setEnabled(boolean isEnabled) {
+	// Do nothing, it's a combobox so it's just readonly
+    }
+
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#setFieldValue(java.lang.Object)
+     */
+    public void setFieldValue(Object value) {
+	this.component.setFieldValue(value);
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#setReadOnly()
+     */
+    @Override
+    protected void setReadOnly() {
+	// Do nothing, it's a combobox so it's just readonly
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#setValue(java.lang.Object)
+     */
+    @Override
+    public void setValue(Object value) {
+	Object item;
+	for (int i=0;i<this.items.length;i++){
+	    item = this.items[i].getValue();
+	    if (item==null) continue; 
+	    
+	    if (item.equals(value)){
+		this.combo.setSelectedIndex(i+1);
+		break;
+	    }
+	}
+    }
+
+
+ 
+}
\ No newline at end of file
Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JDynObjectDynfieldComponentFactory.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JDynObjectDynfieldComponentFactory.java	(revision 0)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JDynObjectDynfieldComponentFactory.java	(revision 168)
@@ -0,0 +1,86 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+*
+* Copyright (C) 2007-2008 Infrastructures and Transports Department
+* of the Valencian Government (CIT)
+* 
+* This program is free software; you can redistribute it and/or
+* modify it under the terms of the GNU General Public License
+* as published by the Free Software Foundation; either version 2
+* of the License, or (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
+* MA  02110-1301, USA.
+* 
+*/
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 Institute of New Imaging Technologies (INIT): 
+ *   http://www.init.uji.es
+ * Geographic Information research group: 
+ *   http://www.geoinfo.uji.es
+ * Universitat Jaume I, Spain
+ */
+
+/**
+ * 
+ */
+package org.gvsig.tools.swing.impl.dynobject.dynfield;
+
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.dynobject.DynField;
+import org.gvsig.tools.service.ServiceException;
+import org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent;
+import org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponentFactory;
+import org.gvsig.tools.swing.api.dynobject.dynfield.ValueField;
+import org.gvsig.tools.swing.spi.AbstractJDynFieldComponentFactory;
+
+/**
+ * @author <a href="mailto:reinhold@uji.es">cmartin</a>
+ *
+ */
+public class JDynObjectDynfieldComponentFactory extends AbstractJDynFieldComponentFactory
+implements JDynFieldComponentFactory {
+
+    private static final String DESCRIPTION = null;
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponentFactory#createJDynFieldComponent(org.gvsig.tools.dynobject.DynField, org.gvsig.tools.swing.api.dynobject.dynfield.ValueField)
+     */
+    public JDynFieldComponent createJDynFieldComponent(DynField dynField,
+	    ValueField dynObject) throws ServiceException {
+	return new JDynObjectDynFieldComponent(dynField,dynObject);
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.AbstractSwingServiceFactory#getFactoryDescription()
+     */
+    @Override
+    public String getFactoryDescription() {
+	// TODO Auto-generated method stub
+	return this.DESCRIPTION;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.AbstractSwingServiceFactory#getFactorySubType()
+     */
+    @Override
+    public String getFactorySubType() {
+	return null;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.AbstractSwingServiceFactory#getFactoryType()
+     */
+    @Override
+    public Integer getFactoryType() {
+	return DataTypes.DYNOBJECT;
+    }
+
+}
Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/DefaultJNDynFieldComponentFactory.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/DefaultJNDynFieldComponentFactory.java	(revision 0)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/DefaultJNDynFieldComponentFactory.java	(revision 168)
@@ -0,0 +1,110 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+*
+* Copyright (C) 2007-2008 Infrastructures and Transports Department
+* of the Valencian Government (CIT)
+* 
+* This program is free software; you can redistribute it and/or
+* modify it under the terms of the GNU General Public License
+* as published by the Free Software Foundation; either version 2
+* of the License, or (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
+* MA  02110-1301, USA.
+* 
+*/
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 Institute of New Imaging Technologies (INIT): 
+ *   http://www.init.uji.es
+ * Geographic Information research group: 
+ *   http://www.geoinfo.uji.es
+ * Universitat Jaume I, Spain
+ */
+
+/**
+ * 
+ */
+package org.gvsig.tools.swing.impl.dynobject.dynfield;
+
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.dynobject.DynClass;
+import org.gvsig.tools.dynobject.DynField;
+import org.gvsig.tools.service.ServiceException;
+import org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent;
+import org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponentFactory;
+import org.gvsig.tools.swing.api.dynobject.dynfield.ValueField;
+import org.gvsig.tools.swing.spi.AbstractJDynFieldComponentFactory;
+
+/**
+ * @author <a href="mailto:reinhold@uji.es">cmartin</a>
+ *
+ */
+public class DefaultJNDynFieldComponentFactory extends AbstractJDynFieldComponentFactory
+implements JDynFieldComponentFactory {
+
+    private Integer dataType = null;
+    private DynClass dynClass = null;
+
+    /**
+     * @param dataType
+     */
+    public DefaultJNDynFieldComponentFactory(DynClass dynClass) {
+	this.dataType = DataTypes.DYNOBJECT;
+	this.dynClass = dynClass;
+    }
+
+
+    /**
+     * @param dataType
+     */
+    public DefaultJNDynFieldComponentFactory(Integer dataType) {
+	this.dataType = dataType;
+    }
+
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponentFactory#createJDynFieldComponent(org.gvsig.tools.dynobject.DynField, org.gvsig.tools.swing.api.dynobject.JDynObjectComponent)
+     */
+    public JDynFieldComponent createJDynFieldComponent(DynField dynField,
+	    ValueField valueField) throws ServiceException {
+	return new JNDynFieldComponent(valueField, dynField);
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.AbstractSwingServiceFactory#getFactoryDescription()
+     */
+    @Override
+    public String getFactoryDescription() {
+	return null;
+    }
+
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.serv.field.AbstractJDynFieldComponentFactory#getFactorySubType()
+     */
+    @Override
+    public String getFactorySubType() {
+	if (dynClass!=null)
+	    return this.dynClass.getFullName();
+	return null;
+    }
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.serv.field.AbstractJDynFieldComponentFactory#getFactoryType()
+     */
+    @Override
+    public Integer getFactoryType() {
+	if (dataType!=null)
+	    return dataType;
+	return DataTypes.LIST;
+    }
+
+    
+
+}
